{$M 4096, 0, 4096}

Uses
	Crt, Dos, Strings;

const
	{ PKTPM Int }
    PKTPM_INT			= $65;
	{ Memory Allocation }
    CANT_BUFFERS 		= 20;
    { Error Codes }
    ERR_INVALIDCOMMAND  = 1;
    ERR_NODATA 			= 2;
    { ASM }
	CARRY_FLAG			= 1;
    { Various codes used in packet drivers }
	PKT_INT				= $60;
	DRIVER_INFO			= 1;
	ACCESS_TYPE			= 2;
	SET_RCV_MODE		= 20;
	ANYTYPE				= $FFFF;

Type
	TBuffer = record
    	InUse: BYTE;
        Data: Array[0..1517] of char;
    end;

Const
	BUFFER_SIZE = SizeOf(TBuffer);

Var
	PDHandle: WORD;
    Buffer: Array[0..CANT_BUFFERS - 1] of TBuffer;

Procedure pktReceiver; far; assembler;
ASM
  PUSH AX                      { Push the registers we're going to use   }
  PUSH DX                      { to the stack                            }
  PUSH DS

  { Verify the reason for the call }
  CMP  AX,0001                 { AX = 1 means buffer has been copied }
  JZ   @@FrameCopied
  CMP  AX,0000                 { AX = 0 means we have to allocate a buffer }
  JZ   @@AllocMemory
  JMP  @@EXIT                  { Something else (error?) }

@@AllocMemory:

  { Iterate through our buffers, looking for an unused one }
  MOV  DX,SEG Buffer
  MOV  DS,DX					{ DS:DI points to Buffer }
  MOV  DI,OFFSET Buffer
  MOV  DX,0						{ DX = Counter }
@@LazoBuffers:
  MOV  AH,BYTE PTR DS:[DI]      { "InUse" Field }
  CMP  AH,0						{ Structure in use ? }
  JE   @@BufferListo
  ADD  DI,BUFFER_SIZE			{ Next structure }
  INC  DX
  CMP  DX,CANT_BUFFERS			{ If we reached the last buffer, we quit }
  JNE  @@LazoBuffers

  { There's no free buffer. Set ES and DI to Cero, and leave }
  MOV  DX,0
  MOV  ES,DX
  MOV  DI,0
  JMP  @@Exit

@@BufferListo:
  { We found a Buffer. DS:DI points to the structure to use. We have to }
  { return the segment in ES and the offset in DI.				        }
  MOV  BYTE PTR DS:[DI], 1		{ Set "InUse" to 1 }
  INC  DI						{ DS:DI now points to Data }
  MOV  DX,DS
  MOV  ES,DX                    { ES:DI now points to Data }
  JMP  @@Exit

@@FrameCopied:

@@Exit:

  POP  DS
  POP  DX
  POP  AX
end;

procedure PKTPMServiceRoutine; assembler;
asm
	JMP  @@Start

    MOV AX,0
    MOV AX,0
    MOV AX,0
    MOV AX,0
    MOV AX,0
    MOV AX,0
    MOV AX,0
    MOV AX,0
    MOV AX,0
    MOV AX,0
    MOV AX,0
    MOV AX,0
    MOV AX,0
    MOV AX,0

@@Start:
    PUSH DX
	PUSH DS
    PUSH SI
    PUSH ES
    PUSH DI

    { What are the asking for? }
	CMP	 AX,1
    JE	 @@Check
    CMP  AX,2
    JE   @@Send
    CMP  AX,3
    JE	 @@MovePacket
    CMP  AX,4
    JE   @@GetAddress
    MOV  BL,ERR_INVALIDCOMMAND
    JMP  @@FIN

{**************************************************************************
Function 1: Verify if PKTPM is loaded.
**************************************************************************}
@@Check:
    MOV  AX,1234
    JMP  @@Fin

{**************************************************************************
Function 2: Send packet
**************************************************************************}
@@Send:
	MOV  AH, 4
    MOV  DX,DS
	MOV  ES,DX
    INT  60H
    JC   @@SendErr
    MOV  BL,0
    JMP  @@Fin
@@SendErr:
	MOV  BL,DH
    JMP  @@Fin

{**************************************************************************
Function 3: Get first packet from queue.
**************************************************************************}
@@MovePacket:
	MOV  DX,SEG Buffer
    MOV  ES,DX
    MOV  DI,OFFSET Buffer			{ ES:DI points to first Buffer }
    MOV  DX,0						{ DX: Counter }
@@Lazo:
	MOV  AH,BYTE PTR ES:[DI]		{ "InUse" Field }
	CMP  AH,1						{ InUse = 0? }
    JE   @@Dato
    ADD  DI,BUFFER_SIZE
    INC  DX
	CMP  DX,CANT_BUFFERS
    JNE  @@Lazo                     { Continue while there are more buffers }
	MOV  BL,ERR_NODATA				{ to check.								}
    JMP  @@Fin

@@Dato:
	{ ES:DI points to the Buffer }
	PUSH ES
    PUSH DI
    INC  DI							{ ES:DI points to Data }
    MOV  DX,0						{ DX: Counter }
@@Copiar:
	MOV  BL, BYTE PTR ES:[DI]
    MOV  BYTE PTR DS:[SI], BL
    ADD  SI,1
    ADD  DI,1
    INC  DX
	CMP  DX,1517
    JNE  @@Copiar
    POP  DI
    POP  ES
    { Set "InUse" to CERO }
    MOV  BYTE PTR ES:[DI],0
    MOV  BL,0
    JMP  @@Fin

{**************************************************************************
Function 4: Get network card's address (MAC)
**************************************************************************}
@@GetAddress:
	MOV  DX,SEG PDHandle
    MOV  DS,DX
    MOV  SI,OFFSET PDHandle
    MOV  BX,WORD PTR DS:[SI]
	MOV  AH,6
	INT  60H
    JMP  @@Fin

@@Fin:
	POP  DI
    POP  ES
	POP  SI
    POP  DS
    POP  DX
	IRET
end;

(*
Function GetMessage(Var P: TEthernetPacket): Boolean;
Var
    Regs: Registers;
begin
	Regs.AX := 3;
    Regs.DS := Seg(P);
    Regs.SI := Ofs(P);
    Intr(PKTPM_INT, Regs);
    GetMessage := (Regs.BL = 0);
end;

Procedure GetAddress;
Var
	Regs: Registers;
    Addr: TEthernetAddress;
begin
	Regs.AX := 4;
    Regs.CX := 6;
    Regs.ES := Seg(Addr);
    Regs.DI := Ofs(Addr);
   	Intr(PKTPM_INT, Regs);
end;
*)

Function TestForPD: Boolean;
Const
	Signature = 'PKT DRVR';
Var
	P: PChar;
    i: Integer;
    Buff: array[0..20] of Char;
Begin
	TestForPD := True;
	GetIntVec($60, Pointer(P));
    for i := 1 to 10 do begin
    	FillChar(Buff, SizeOf(Buff), 0);
        Move(P^, Buff, Length(Signature));
        if StrPas(Buff) = Signature then Exit;
	    Inc(P);
	end;
    TestForPD := False;
end;

Function InitPD(Var DriverName: String): Boolean;
Var
	IfClass: BYTE;
    TypeField: WORD;
	Regs: Registers;
begin
	InitPD := False;
	{ Obtain info for the packet driver }
	With Regs do begin
	    AH := DRIVER_INFO;
    	AL := $FF;
    	BX := 0;
    	Intr(PKT_INT, Regs);
    	if (Regs.Flags and CARRY_FLAG) = CARRY_FLAG then Exit;
        IfClass := CH;
        DriverName := StrPas(Ptr(DS, SI));
    end;

    { Register with packet driverd }
	With Regs do begin
    	AH := ACCESS_TYPE;
    	AL := IfClass;
    	BX := ANYTYPE;
    	CX := 0;
    	DL := 0;
    	DS := Seg(TypeField);
    	SI := Ofs(TypeField);
    	ES := Seg(PktReceiver);
    	DI := Ofs(PktReceiver);
    	Intr(PKT_INT, Regs);
    	if (Flags and CARRY_FLAG) = CARRY_FLAG then Exit;
      	PDHandle := AX;
	end;

	{ Set receive mode to 3: receive packets for this board or broadcast }
	with Regs do begin
    	AH := SET_RCV_MODE;
    	BX := PDHandle;
    	CX := 3;
    	Intr(PKT_INT, Regs);
    	if (Flags and CARRY_FLAG) = carry_flag then Exit;
    end;

    { Done! }
	InitPD := True;
end;


Var
	P: PChar;
	AntInt: Procedure;
    DriverName: String;
{    Msg: TEthernetPacket;	}
begin

    DirectVideo := False;
    WriteLn('Pkt-PM 1.2 (c) 2001, Diego De Marco. Freeware.');
    FillChar(Buffer, SizeOf(Buffer), 0);

    { PKT-PM already loaded? }
	GetIntVec(PKTPM_INT, Pointer(P));
    if Copy(StrPas(@P[10]), 1, 6) = 'PKT-PM' then begin
    	WriteLn('ERROR: PKT-PM already loaded.');
        Exit;
    end;

	{ Check for packet driver }
	if not TestForPD then begin
    	WriteLn('ERROR: No packet driver detected at int 0x60.');
    	Exit;
    end;

    { Register with Packet Driver }
	if not InitPD(DriverName) then begin
    	WriteLn('ERROR: Driver detected at 0x60, but couldn''t attach to it.');
    	Exit;
    end;

    { Write signature }
    P := @PKTPMServiceRoutine;
    P[10] := 'P';
    P[11] := 'K';
    P[12] := 'T';
    P[13] := '-';
    P[14] := 'P';
    P[15] := 'M';

    { Hook to PKTPM_INT }
    GetIntVec(PKTPM_INT, @AntInt);
    SetIntVec(PKTPM_INT, @PKTPMServiceRoutine);

    { Done }
    WriteLn('Interface to Packet-Drivers for Protected Mode Installed.');
    WriteLn('  Succesfully attached to: ', DriverName);
	Keep(0);

{	GetAddress;
    SetIntVec(PKTPM_INT, @AntInt);
}
end.