uses
    Network, PktDrv, Crt, IP, Sockets, Util, SysUtils, WebSrv, WebFS;

Procedure HomePage(Server: TWebServer; Request: TWebRequest;
  Response: TWebResponse);
begin
    Response.Content :=
      '<HTML><TITLE>Dynamic Page</TITLE>' +
	  '<H1>This is a Dynamic Page</H1>' +
	  'Today it''s ' + DateTimeToStr(Now) + '<br>' +
      '</HTML>';
end;

Procedure WebAdmin(Server: TWebServer; Request: TWebRequest;
  Response: TWebResponse);
begin
    Response.Content :=
      '<HTML><TITLE>Web Administration</TITLE>' +
	  '<H1>Web Administration</H1>' +
	  'This page is under construction.' +
      '</HTML>';
end;


Const
	MY_IP			= '128.128.1.217';
	MY_NETMASK		= '255.255.255.0';
	MY_GATEWAY		= '128.128.1.1';

Var
    IPHandle: Integer;
    Server: TWebServer;
    IPConf: TIPAdapterConfig;
    Adapter: TPacketDriverAdapter;
begin
    // Create an Adapter object representing out network adapter.
    Adapter := TPacketDriverAdapter.Create;

    // If the adapter works fine, we bind the TCP/IP protocol.
    if Adapter.Status <> asOk then begin
        WriteLn('Could not initialise network adapter. Packet Driver not loaded.');
        Adapter.Free;
		Halt(2);
    end;
    IPConf.DHCP      := False;
	IPConf.IPAddress := IP_StringToAddr(MY_IP);
	IPConf.NetMask   := IP_StringToAddr(MY_NETMASK);
    IPConf.Gateway   := IP_StringToAddr(MY_GATEWAY);
    IPHandle         := IP_Init(Adapter, IPConf);
    if IPHandle = 0 then begin
        WriteLn('Could not initialise IP stack. Wrong Parameters.');
        Adapter.Free;
        Halt(3);
    end;

    // Bring up a Web Server
    ClrScr;
	Write('Starting Web Server... ');
    Server := TWebServer.Create;
    if not Server.Start(INADDR_ANY, Swap(WORD(80)), '.\',
      '/pages/index.htm') then begin
        WriteLn('Error ', SocketError, ' starting Web Server.');
        Server.Free;
        IP_Deinit(IPHandle);
        Adapter.Free;
        Halt(4);
    end;
    WriteLn('Started.');

    // Add Web Server Actions
    Server.AddAction('/index', HomePage);
    Server.AddAction('/webadmin', WebAdmin);
    StartWebFS(Server, '/filesystem');

    // Loop until user presses <Esc>
    Repeat NET_Work Until KeyPressed and (ReadKey = #27);

    // Close everything
    Server.Free;
    IP_Deinit(IPHandle);
    Adapter.Free;
end.
