Unit Util;

{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
interface
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
Uses
    Go32, Crt, Dos, Strings, SysUtils;


{**************************************************************************
                        Constantes Pblicas
**************************************************************************}
const
    CR     = #13;
    LF     = #10;
    CRLF   = CR + LF;

{**************************************************************************
                            Tipos Pblicos
**************************************************************************}
Type
	PScreenBuffer = ^TScreenBuffer;
	TScreenBuffer = array[0..7999] of char;

{**************************************************************************
                            Variables Pblicas
**************************************************************************}

{**************************************************************************
                            Funciones Pblicas
**************************************************************************}
{A}

{B}
Procedure Beep;

{C}
Procedure ClearError;
Function CurDir: string;

{D}
Function Day(Fecha: TDateTime): Word;
Function Del(Wildcard: string): integer;

{E}
Function ExtMkDir(Dir: String): Boolean;

{F}
Function FExt(s: String): String;
Function FName(s: String): String;
Function FormatShortDate(Fecha: TDateTime): String;
Function FormatTime(Hora: TDateTime; ConSegundos: Boolean): String;
Function FPath(s: string): string;
Function FileToString(const Archivo: AnsiString): AnsiString;

{G}
Function GoodDir(s: string): String;
Function GoodFileName(s, ext: string): String;
Function GetMSCounter: Comp;

{H}
Function Hour(d: TDateTime): Word;
Function HexToInt(HexStr: AnsiString): DWORD;

{I}
Function IsFile(s: String): Boolean;
Function IsDir(s: string): Boolean;
Function IStr(i: LongInt; ancho: integer): String;
Function IVal(s: String): LongInt;
Function IsVGA50: Boolean;

{J}

{L}

{M}
Function  Max(a, b: LongInt): LongInt;
Function  MemComp(p, q: PChar; largo: Word): Boolean;
Procedure MemMove(Dest, Src: PChar; Count: Word);
Function  MemPos(p, q: PChar; largo: Word): PChar;
Function  Month(Fecha: TDateTime): Word;
Procedure MoveToMyOwnDir;
Function  Minute(d: TDateTime): Word;

{P}
Function PadC(s: string; ancho: Integer; caracter: char): string;
Function PadL(s: string; ancho: Integer; caracter: char): string;
Function PadR(s: string; ancho: Integer; caracter: char): string;
Function ParseParamByNumber(Texto: AnsiString; NumParam: Integer; const Separador: AnsiString): string;
Function Power(a, b: LongInt): LongInt;

{R}
Function Replicate(caracter: char; veces: Integer): string;
Function StrRight(s: string; cuantos: Integer): string;
Function RStr(i: Real; Ancho, Dec: Integer): String;
Function RVal(s: String): Real;
Procedure RestoreScreen(Scrn: TScreenBuffer);

{S}
Function  Space(veces: Integer): string;
Function  StrLeft(s: string; cuantos: Integer): string;
Function  Second(d: TDateTime): Word;
procedure SaveScreen(var Scrn: TScreenBuffer);
Function  SwapDWORD(D: DWORD): DWORD;
Function StringToFile(const Datos, Archivo: AnsiString): Boolean;

{T}
Function TempFile: string;

{U}

{W}

{X}

{Y}
Function Year(Fecha: TDateTime): Word;
Procedure ResetMachine;


{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
implementation
{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
{**************************************************************************
					Variables Pblicas para la Unidad
**************************************************************************}
Const
	Numeros: Set of char = ['0','1','2','3','4','5','6','7','8','9','.', '-'];

Type
    TDPMIRec = packed record
        EDI: DWORD;
        ESI: DWORD;
        EBP: DWORD;
        NA:  DWORD;
        EBX: DWORD;
        EDX: DWORD;
        ECX: DWORD;
        EAX: DWORD;
        CPU: WORD;
        ES:  WORD;
        DS:  WORD;
        FS:  WORD;
        GS:  WORD;
        IP:  WORD;
        CS:  WORD;
        SP:  WORD;
        SS:  WORD;
    end;

Var
    VideoBase: WORD;
    DPMIRec: TDPMIRec;

{A}

{B}
Procedure Beep;
begin
	Sound(1000);
	Delay(200);
    NoSound;
end;

{C}
Procedure ClearError;
Begin
	if IOResult <> 0 then;
end;

Function CurDir: string;
var
	s: string;
begin
	GetDir(0, s);
	CurDir := GoodDir(s);
end;

{D}
Function Day(Fecha: TDateTime): Word;
var
    y, m, d: WORD;
Begin
    DecodeDate(Fecha, y, m, d);
    Day := d;
end;

Function Del(wildcard: string): integer;
var
    camino: string;
	Archivo: TSearchRec;
    Resu, Count: Integer;
begin
    Count  := 0;
	Camino := FPath(wildcard);
    Resu := FindFirst(WildCard, faArchive, Archivo);
    while Resu = 0 do begin
        if DeleteFile(Camino + Archivo.name) then Inc(Count);
        Resu := FindNext(Archivo);
    end;
    FindClose(Archivo);
    Del := Count;
end;

{E}
Function ExtMkDir(Dir: String): Boolean;
var
	a: String;
	s: String;
	n: Integer;
Begin
	s := Trim(Dir);
	a := '';
	Repeat
		n := Pos('\', s);
		if n = 0 then a := a + s + ' ' else a := a + StrLeft(s, n);
		s := Copy(s, n + 1, 255);
		{$I-}
		MkDir(StrLeft(a, Length(a) -1));
		{$I+}
		ClearError;
	Until n = 0;
	ExtMkDir := IsDir(Dir);
end;

{F}
Function FName(s: String): String;
begin
    FName := ExtractFileName(s);
end;

Function FExt(s: String): String;
begin
    FExt := ExtractFileExt(s);
end;

Function FormatShortDate(Fecha: TDateTime): String;
Var
    y, m, d: WORD;
Begin
    DecodeDate(Fecha, y, m, d);
    FormatShortDate :=
      PadL(IntToStr(d), 2, '0') + '/' +
      PadL(IntToStr(m), 2, '0') + '/' +
      PadL(IntToStr(y), 4, '0');
end;

Function FormatTime(Hora: TDateTime; ConSegundos: Boolean): String;
Var
    ss: String[20];
    h, m, s, ms: WORD;
Begin
    DecodeTime(Hora, h, m, s, ms);
    ss :=
      PadL(IntToStr(h), 2, '0') + ':' +
      PadL(IntToStr(m), 2, '0');
    if ConSegundos then ss := ss + ':' +
      PadL(IntToStr(s), 2, '0');
	FormatTime := ss;
end;

Function FPath(s: string): string;
begin
    FPath := GoodDir(ExtractFilePath(s));
end;

Function FileToString(const Archivo: AnsiString): AnsiString;
Var
	Handle: Integer;
begin
	Result := '';
	Handle := FileOpen(Archivo, fmOpenread);
	if (Handle < 0) then Exit;
	SetLength(Result, FileSeek(Handle, 0, 2));
	if Length(Result) > 0 then begin
		FileSeek(Handle, 0, 0);
		FileRead(Handle, Result[1], Length(Result));
	end;
	FileClose(Handle);
end;


{G}
Function GoodDir(s: string): String;
Begin
	if s = '' then
		GoodDir := ''
	else Begin
        s := Trim(s);
		if StrRight(s, 1) = '\' then GoodDir := s else GoodDir := s + '\';
	end;
end;

Function GoodFileName(s, ext: string): String;
begin
	if s = '' then
		GoodFileName := ''
	else if Pos('.', s) = 0 then begin
		if Pos('.', ext) = 0 then ext := '.' + ext;
		GoodFileName := s + ext;
	end else begin
		GoodFileName := s;
	end;
end;

Function GetMSCounter: Comp;
Const
    AntTicks: DWORD = 0;
    AntResult: Comp = 0;
Var
    TickDiff, CurrTicks: DWORD;
begin
    DosMemGet($0040, $006C, CurrTicks, 4);
    if AntTicks = 0 then AntTicks := CurrTicks;
    if CurrTicks >= AntTicks then begin
        TickDiff := (CurrTicks - AntTicks);
    end else begin
        TickDiff := (1573040 - AntTicks) + CurrTicks;
    end;
    AntTicks  := CurrTicks;
    AntResult := AntResult + Comp(TickDiff) * 55;
    Result    := AntResult;
end;


{H}
Function Hour(d: TDateTime): Word;
Var
    h, m, s, ms: WORD;
Begin
    DecodeTime(d, h, m, s, ms);
    Hour := h;
end;

Function HexToInt(HexStr: AnsiString): DWORD;

    Function DigitoHexa(H: Char): Integer;
    begin
        case UpCase(h) of
            '0'..'9': Result := Ord(h) - 48;
            'A'..'F': Result := Ord(h) - 55;
            else Result := -1;
        end;
    end;

Var
    d, i: Integer;
    Factor: DWORD;
begin
    Result := 0;
    Factor := 1;
    For i := Length(HexStr) downto 1 do begin
        // El dgito que estamos analizando es vlido ?
        d := DigitoHexa(HexStr[i]);
        if d = -1 then begin
            Result := 0;
            Exit;
        end;
        // Sumamos al total
        Result := Result + (Factor * WORD(d));
        // Pasamos al dgito siguiente
        Factor := Factor * $10;
    end;
end;

Function Minute(d: TDateTime): Word;
Var
    h, m, s, ms: WORD;
Begin
    DecodeTime(d, h, m, s, ms);
    Minute := m;
end;

Function Second(d: TDateTime): Word;
Var
    h, m, s, ms: WORD;
Begin
    DecodeTime(d, h, m, s, ms);
    Second := s;
end;

{I}
Function IsDir(s: string): Boolean;
Var
	f: File;
begin
	Assign(f, GoodDir(s) + TempFile);
	{$I-}
	ReWrite(f);
	Close(f);
	Erase(f);
	{$I+}
	IsDir := (IOResult = 0);
end;

Function IsFile(s: String): Boolean;
Var
    f: File;
	AntFileMode: Integer;
begin
	AntFileMode := FileMode;
	FileMode := 0;
	Assign(f, s);
	{$I-}
	Reset(f);
	if IOResult = 0 then Begin
		IsFile := True;
		Close(f);
	end else begin
		IsFile := False;
	end;
	{$I+}
	FileMode := AntFileMode;
end;

Function IsVGA50: Boolean;
var
	AntX, AntY: Byte;
begin
	AntX := WhereX;
	AntY := WhereY;
	GotoXY(1, 45);
	IsVGA50 := (WhereY = 45);
	GotoXY(AntX, AntY);
end;

Function IStr(i: LongInt; ancho: integer): String;
Var
	s: string;
Begin
	if i = 0 then
    	IStr := Space(ancho)
    else Begin
		Str(i, s);
		if ancho = 0 then IStr := s else IStr := PadL(s, ancho, ' ');
    end;
end;

Function IVal(s: String): LongInt;
Var
	i: Byte;
	Code: integer;
	Resu: LongInt;
	ss: String;
Begin
    s := Trim(s); ss := '';
	For i := 1 to Length(s) do Begin
		if s[i] in numeros then ss := ss + s[i] else break;
	end;
	Val(ss, resu, code);
	IVal := resu;
end;

{J}

{L}

{M}
Function Max(a, b: LongInt): LongInt;
Begin
	if a > b then Max := a else Max := b;
end;

Function MemComp(p, q: PChar; largo: Word): Boolean;
Var
	i: Word;
Begin
	MemComp := true;
	for i := 0 to largo - 1 do
		if p[i] <> q[i] then Begin
			MemComp := False;
			break;
		end;
end;

Procedure MemMove(Dest, Src: PChar; Count: Word);
Begin
	Move(Src^, Dest^, Count);
end;

Function MemPos(p, q: PChar; largo: Word): PChar;
Var
	i: Word;
	Resp: PChar;
Begin
	i := 0;
	Resp := nil;
	While (Resp = nil) and (i < largo) do Begin
		Resp := StrPos(p + i, q);
		i := i + StrLen(p) + 1;
	end;
	MemPos := resp;
end;

Function Month(Fecha: TDateTime): Word;
Var
    y, m, d: WORD;
Begin
    DecodeDate(Fecha, y, m, d);
    Month := m;
end;

Procedure MoveToMyOwnDir;
Var
	s: String;
begin
	s := FPath(ParamStr(0));
	if StrRight(s, 1) = '\' then s := StrLeft(s, Length(s) - 1);
	if Copy(ParamStr(0), 2, 1) = ':' then  ChDir(s);		{Me cambio al Directorio}
end;

{P}
Function PadC(s: string; ancho: Integer; caracter: char): string;
begin
  s := PadL(s, (ancho + Length(s)) div 2, caracter);
  PadC := PadR(s, ancho, caracter);
end;

Function PadL(s: string; ancho: Integer; caracter: char): string;
begin
	if Length(s) <= ancho then begin
		s := Replicate(caracter, ancho - Length(s)) + s
	end else begin
		s := StrRight(s, ancho);
	end;
	PadL := s;
end;

Function PadR(s: string; ancho: Integer; caracter: char): string;
begin
	if Length(s) <= ancho then begin
		s := s + replicate(caracter, ancho - Length(s))
	end else begin
		s := StrLeft(s, ancho);
	end;
	PadR := s;
end;

Function ParseParamByNumber(Texto: AnsiString; NumParam: Integer; const Separador: AnsiString): String;
Var
	n, i: Integer;
begin
	n := 1;
	Result := '';
	While n <> NumParam do begin
		i := Pos(Separador, Texto);
		if i = 0 then Exit;
		Texto := TrimLeft(Copy(Texto, i + Length(Separador), Length(Texto)));
		Inc(n);
	end;
	i := Pos(Separador, Texto); if i > 0 then Texto := Copy(Texto, 1, i - 1);
	Result := Trim(Texto);
end;

Function Power(a, b: LongInt): LongInt;
var
	cont, resp: LongInt;
begin
	if b < 0 then begin
		Power := 0;
	end else if b = 0 then begin
		Power := 1;
	end else begin
		resp := 1;
		for cont := 1 to b do begin
			resp := resp * a;
		end;
		power := resp;
	end;
end;

{R}
Function Replicate(caracter: char; veces: Integer): string;
begin
    if veces = 0 then begin
    	Result := '';
    end else begin
	    SetLength(Result, veces);
    	FillChar(Result[1], Length(Result), caracter);
    end;
end;

Procedure ResetMachine;
Var
    Regs: Registers;
begin
    FillChar(DPMIRec, SizeOf(DPMIRec), 0);
    DPMIRec.CS   := $FFFF;
    DPMIRec.IP   := $0000;
    DPMIRec.SS   := 0;
    DPMIRec.SP   := 0;
    DosMemFillChar($0040, $0072, 1, #0);
    {$ASMMODE INTEL}
    asm
        MOV  CX, 0
        MOV  BH, 0
        MOV  AX, DS
        MOV  ES, AX
        MOV  EDI, OFFSET DPMIRec
        MOV  AX, 0301H
        INT  31H
    end;
end;

Procedure RestoreScreen(scrn: TScreenBuffer);
begin
    DosMemPut(VideoBase, 0, Scrn, SizeOf(Scrn));
end;

Function RStr(i: Real; Ancho, Dec: Integer): String;
Var
    s: String;
Begin
	if i = 0 then
    	RStr := Space(Ancho)
    else Begin
	    if Ancho = 0 then
			RStr := IStr(Trunc(i), 0)
	    else Begin
    		Str(i:Ancho:Dec, s);
        	RStr := s;
	    end;
    end;
end;

Function RVal(s: String): Real;
Var
	i: Byte;
	Resu: Real;
	ss: String;
	Code: integer;
Begin
    s := Trim(s);
	ss := '';
	For i := 1 to Length(s) do Begin
		if s[i] in numeros then ss := ss + s[i] else break;
	end;
	Val(ss, Resu, code);
	RVal := Resu;
end;

{S}
Function Space(veces: Integer): string;
begin
	Space := Replicate(' ', veces);
end;

Procedure SaveScreen(Var Scrn: TScreenBuffer);
Begin
    DosMemGet(VideoBase, 0, Scrn, SizeOf(Scrn));
end;

Function StrLeft(s: string; cuantos: Integer): string;
begin
	if Cuantos <= 0 then
    	StrLeft := ''
    else Begin
		if Length(s) > cuantos then s := Copy(s, 1, cuantos);
		StrLeft := s;
    end;
end;

Function StrRight(s: string; cuantos: Integer): string;
begin
	StrRight := Copy(s, Length(s) - Cuantos + 1, 255);
end;

Function SwapDWORD(D: DWORD): DWORD;
var
	r1, r2: packed Array[1..4] of BYTE;
begin
	Move(D, r1, 4);
    r2[1] := r1[4];
    r2[2] := r1[3];
    r2[3] := r1[2];
    r2[4] := r1[1];
    Move(r2, D, 4);
    SwapDWORD := D;
end;

Function StringToFile(const Datos, Archivo: AnsiString): Boolean;
Var
	Handle: Integer;
begin
	Result := False;
	Handle := FileCreate(Archivo);
	if (Handle <= 0) then Exit;
	Result := FileWrite(Handle, Datos[1], Length(Datos)) = Length(Datos);
	FileClose(Handle);
end;


{T}
Function TempFile: string;
var
  cont, n: byte;
  s: string;
begin
  s := '';
  for cont := 1 to 8 do begin
	n := Random(9);
	s := s + chr(48 + n);
  end;
  TempFile := s;
end;

{X}

{Y}
Function Year(Fecha: TDateTime): Word;
Var
    y, m, d: WORD;
Begin
    DecodeDate(Fecha, y, m, d);
    Year := y;
end;



{XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
El Cuerpo de la Base de la Unidad
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX}
var
    Regs: TRealregs;
begin
    RealIntr($11, Regs);
    if (Regs.ax and 48) = 48 then VideoBase := $B000
	  else VideoBase := $B800;
	Randomize;
end.
